{-# OPTIONS_GHC -fglasgow-exts #-}

module RedPair where {

import Show;
import Term;
import Util;
import HOL;
import ErrorMonad;
import Product_Type;
import List;

checkRedPairProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      [Char] ->
                        [[Char]] ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkRedPairProc checkSS checkNSS name representation p rP r =
  let {
    a = computeSplit (\ foo -> isValue (checkSS foo)) p;
    (sp, nSp) = a;
  } in catcha
         (bind (bind (catcha
                       (catcha (checkAllMI checkNSS r) (\ x -> errora (snd x)))
                       (\ x ->
                         errora
                           (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                              'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i',
                              'n', 'g', ' ', 'T', 'R', 'S']
                             : x)))
                 (\ x ->
                   catcha
                     (catcha (checkAllMI checkNSS nSp)
                       (\ xa -> errora (snd xa)))
                     (\ xa ->
                       errora
                         (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                            'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i',
                            'n', 'g', ' ', 'D', 'P', 's']
                           : xa))))
           (\ x ->
             catcha (checkSubset nSp rP)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e', 'r',
                          'r', 'o', 'r'],
                         ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o', 'n', 't',
                           'a', 'c', 't', ' ', 'o', 'n', 'e', ' ', 'o', 'f',
                           ' ', 't', 'h', 'e', ' ', 'C', 'e', 'T', 'A', ' ',
                           'm', 'e', 'm', 'b', 'e', 'r', 's'],
                         ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l', '-', 'i',
                           'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'k', '.',
                           'u', 'i', 'b', 'k', '.', 'a', 'c', '.', 'a', 't',
                           '/', 's', 'o', 'f', 't', 'w', 'a', 'r', 'e', '/',
                           'c', 'e', 't', 'a'],
                         ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o', 'r', 'm',
                           'a', 't', 'i', 'k', '.', 'u', 'i', 'b', 'k', '.',
                           'a', 'c', '.', 'a', 't']];
                   }))))
         (\ x ->
           errora
             (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
                'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u', 'c', 't',
                'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h',
                'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g']
               : append representation ([] : x)));

checkRuleRemovalProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      [Char] ->
                        [[Char]] ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkRuleRemovalProc checkSS checkNSS name representation r rR =
  let {
    a = computeSplit (\ foo -> isValue (checkSS foo)) r;
    (sp, nSp) = a;
  } in catcha
         (bind (bind (catcha
                       (catcha (checkAllMI checkNSS r) (\ x -> errora (snd x)))
                       (\ x ->
                         errora
                           (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'h',
                              'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i',
                              'n', 'g', ' ', 'r', 'u', 'l', 'e', 's']
                             : x)))
                 (\ x ->
                   catcha (checkSubset nSp rR)
                     (\ xa ->
                       errora
                         (case checkSS xa of {
                           Lefta err -> err;
                           Righta ok ->
                             [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e',
                                'r', 'r', 'o', 'r'],
                               ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o',
                                 'n', 't', 'a', 'c', 't', ' ', 'o', 'n', 'e',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'C',
                                 'e', 'T', 'A', ' ', 'm', 'e', 'm', 'b', 'e',
                                 'r', 's'],
                               ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l',
                                 '-', 'i', 'n', 'f', 'o', 'r', 'm', 'a', 't',
                                 'i', 'k', '.', 'u', 'i', 'b', 'k', '.', 'a',
                                 'c', '.', 'a', 't', '/', 's', 'o', 'f', 't',
                                 'w', 'a', 'r', 'e', '/', 'c', 'e', 't', 'a'],
                               ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o',
                                 'r', 'm', 'a', 't', 'i', 'k', '.', 'u', 'i',
                                 'b', 'k', '.', 'a', 'c', '.', 'a', 't']];
                         }))))
           (\ x ->
             catcha (checkSubset rR r)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e', 'r',
                          'r', 'o', 'r'],
                         ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o', 'n', 't',
                           'a', 'c', 't', ' ', 'o', 'n', 'e', ' ', 'o', 'f',
                           ' ', 't', 'h', 'e', ' ', 'C', 'e', 'T', 'A', ' ',
                           'm', 'e', 'm', 'b', 'e', 'r', 's'],
                         ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l', '-', 'i',
                           'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'k', '.',
                           'u', 'i', 'b', 'k', '.', 'a', 'c', '.', 'a', 't',
                           '/', 's', 'o', 'f', 't', 'w', 'a', 'r', 'e', '/',
                           'c', 'e', 't', 'a'],
                         ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o', 'r', 'm',
                           'a', 't', 'i', 'k', '.', 'u', 'i', 'b', 'k', '.',
                           'a', 'c', '.', 'a', 't']];
                   }))))
         (\ x ->
           errora
             (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
                'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'u', 'l', 'e', ' ', 'r',
                'e', 'm', 'o', 'v', 'a', 'l', ' ', 'p', 'r', 'o', 'c', 'e', 's',
                's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h', 'e', ' ',
                'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g']
               : append representation ([] : x)));

checkMonoRedPairProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                    ((Term a b, Term a b) -> Eithera [[Char]] ()) ->
                      [Char] ->
                        [[Char]] ->
                          [(Term a b, Term a b)] ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] ->
                                [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkMonoRedPairProc checkSS checkNSS name representation p rP r rR =
  let {
    a = computeSplit (\ foo -> isValue (checkSS foo)) p;
    (sp, nSp) = a;
    aa = computeSplit (\ foo -> isValue (checkSS foo)) r;
    (sr, nSr) = aa;
  } in catcha
         (bind (bind (bind (bind (catcha
                                   (catcha (checkAllMI checkNSS nSr)
                                     (\ x -> errora (snd x)))
                                   (\ x ->
                                     errora
                                       (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
  'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ',
  'T', 'R', 'S']
 : x)))
                             (\ x ->
                               catcha
                                 (catcha (checkAllMI checkNSS nSp)
                                   (\ xa -> errora (snd xa)))
                                 (\ xa ->
                                   errora
                                     (['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ',
'w', 'h', 'e', 'n', ' ', 'o', 'r', 'i', 'e', 'n', 't', 'i', 'n', 'g', ' ', 'D',
'P', 's']
                                       : xa))))
                       (\ x ->
                         catcha (checkSubset rR r)
                           (\ xa ->
                             errora
                               [['p', 'r', 'o', 'b', 'l', 'e', 'm', ':', ' ',
                                  'a', 'd', 'd', 'i', 't', 'i', 'o', 'n', 'a',
                                  'l', ' ']])))
                 (\ x ->
                   catcha (checkSubset nSr rR)
                     (\ xa ->
                       errora
                         (case checkSS xa of {
                           Lefta err -> err;
                           Righta ok ->
                             [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e',
                                'r', 'r', 'o', 'r'],
                               ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o',
                                 'n', 't', 'a', 'c', 't', ' ', 'o', 'n', 'e',
                                 ' ', 'o', 'f', ' ', 't', 'h', 'e', ' ', 'C',
                                 'e', 'T', 'A', ' ', 'm', 'e', 'm', 'b', 'e',
                                 'r', 's'],
                               ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l',
                                 '-', 'i', 'n', 'f', 'o', 'r', 'm', 'a', 't',
                                 'i', 'k', '.', 'u', 'i', 'b', 'k', '.', 'a',
                                 'c', '.', 'a', 't', '/', 's', 'o', 'f', 't',
                                 'w', 'a', 'r', 'e', '/', 'c', 'e', 't', 'a'],
                               ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o',
                                 'r', 'm', 'a', 't', 'i', 'k', '.', 'u', 'i',
                                 'b', 'k', '.', 'a', 'c', '.', 'a', 't']];
                         }))))
           (\ x ->
             catcha (checkSubset nSp rP)
               (\ xa ->
                 errora
                   (case checkSS xa of {
                     Lefta err -> err;
                     Righta ok ->
                       [['i', 'n', 't', 'e', 'r', 'n', 'a', 'l', ' ', 'e', 'r',
                          'r', 'o', 'r'],
                         ['p', 'l', 'e', 'a', 's', 'e', ' ', 'c', 'o', 'n', 't',
                           'a', 'c', 't', ' ', 'o', 'n', 'e', ' ', 'o', 'f',
                           ' ', 't', 'h', 'e', ' ', 'C', 'e', 'T', 'A', ' ',
                           'm', 'e', 'm', 'b', 'e', 'r', 's'],
                         ['h', 't', 't', 'p', ':', '/', '/', 'c', 'l', '-', 'i',
                           'n', 'f', 'o', 'r', 'm', 'a', 't', 'i', 'k', '.',
                           'u', 'i', 'b', 'k', '.', 'a', 'c', '.', 'a', 't',
                           '/', 's', 'o', 'f', 't', 'w', 'a', 'r', 'e', '/',
                           'c', 'e', 't', 'a'],
                         ['c', 'e', 't', 'a', '@', 'i', 'n', 'f', 'o', 'r', 'm',
                           'a', 't', 'i', 'k', '.', 'u', 'i', 'b', 'k', '.',
                           'a', 'c', '.', 'a', 't']];
                   }))))
         (\ x ->
           errora
             (['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'a', 'p', 'p',
                'l', 'y', ' ', 't', 'h', 'e', ' ', 'r', 'e', 'd', 'u', 'c', 't',
                'i', 'o', 'n', ' ', 'p', 'a', 'i', 'r', ' ', 'p', 'r', 'o', 'c',
                'e', 's', 's', 'o', 'r', ' ', 'w', 'i', 't', 'h', ' ', 't', 'h',
                'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g']
               : append representation ([] : x)));

}
